#version 440

layout(triangles) in;
layout(triangle_strip,max_vertices=3) out;

in GVertex {
    vec3 Position;
    vec2 TxtCoord;
  } In[];

out FVertex {
    vec3      Position;
    vec2      TxtCoord;
    vec3      Normal;
    flat vec3 TNormal;
  } Out;

void main ( void )
{
  int  i;
  vec3 v1, v2, nv;

  v1 = In[1].Position - In[0].Position;
  v2 = In[2].Position - In[0].Position;
  nv = normalize ( cross ( v1, v2 ) );
  for ( i = 0; i < 3; i++ ) {
    gl_Position = gl_in[i].gl_Position;
    Out.Position = In[i].Position;
    Out.TxtCoord = In[i].TxtCoord;
    Out.Normal = Out.TNormal = nv;
    EmitVertex ();
  }
  EndPrimitive ();
} /*main*/
