#version 440 

layout(location=0) in vec4 in_Position;
layout(location=1) in vec2 TxtCoord;
layout(location=2) in vec3 Normal;

out GVertex {
  vec3 Position;
  vec3 Normal;
  vec2 TxtCoord;
} Out;

uniform TransBlock {
    mat4 mm, mmti, vm, pm, vpm, vpmi;
    vec4 eyepos;
    vec4 viewport;
  } trb;

void main ( void )
{
  vec4 Pos;

  Out.Position = (Pos = trb.mm * in_Position).xyz;
  Out.Normal = mat3(trb.mmti) * Normal;
  Out.TxtCoord = TxtCoord;
  gl_Position = trb.vpm * Pos;
} /*main*/

