
#define APP2C_GL_MAJOR 4
#define APP2C_GL_MINOR 5

#define STATE_NOTHING 0
#define STATE_TURNING 1

#define MIN_TESS_LEVEL  3
#define MAX_TESS_LEVEL 64


extern GLuint progid[2];
extern GLint  ColourSourceLoc, LightingModelLoc;
extern GLint  lighting_model;
              
extern BSPatchObjf *mypatch;

extern float   model_rot_axis[3], patch_rot_angle0, patch_rot_angle;
extern GLfloat patch_mmatrix[16], patch_mmti[16];

extern TransBl trans;
extern LightBl light;
extern GLuint  matbuf[2];

/*extern GLFWwindow  *mywindow;*/
extern int         win_width, win_height;
extern double      last_xi, last_eta;
extern float       left, right, bottom, top, near, far;
extern int         app_state;
extern float       viewer_rvec[3];
extern float       viewer_rangle;
extern const float viewer_pos0[4];
extern GLint       BSNormals;
extern GLint       TessLevel;
extern char        animate;
extern clock_t     zero_time, start_time;
extern float       clocks_per_sec;
extern char        cnet, skeleton;

void SetupMVPMatrix ( void );
void SetModelMatrix ( GLfloat mm[16], GLfloat mmti[16] );

void SetupPatchMatrix ( void );
void InitViewMatrix ( void );
void RotateViewer ( double deltaxi, double deltaeta );

void InitLights ( void );
void SetBezPatchOptions ( GLint normals, GLint tesslevel );

void ConstructMyPatch ( void );
void DrawMyPatch ( void );

void LoadMyShaders ( void );
void InitMyObject ( void );


/*
void myGLFWErrorHandler ( int error, const char *description );
void ReshapeFunc ( GLFWwindow *win, int width, int height );
void DisplayFunc ( GLFWwindow *win );
void MouseFunc ( GLFWwindow *win, int button, int action, int mods );
void MotionFunc ( GLFWwindow *win, double x, double y );
void CharFunc ( GLFWwindow *win, unsigned int charcode );
*/
void IdleFunc ( void );

void Initialise ( int argc, char **argv );
void Cleanup ( void );
void SetIdleFunc ( void(*IdleFunc)(void) );
void MessageLoop ( void );
