
#define NPROGRAMS      10

#define ROPT_DIRECT     0
#define ROPT_DEFERRED   1
#define ROPT_DEFERRED1  1
#define ROPT_DEFERRED2  2
#define ROPT_DEFERRED3  3
#define ROPT_SHADOW     4
#define ROPT_CUBESHADOW 5

#define DFB_TEXTURES    9

typedef struct {
    int     win_width, win_height;
    float   left, right, bottom, top, near, far;
    double  zoom;
    int     zoomexp;
    float   viewer_rvec[3];
    double  viewer_rangle;
  } Camera;

typedef struct {
    int    width, height;
    GLuint dfbo[2], dtxt[DFB_TEXTURES];
  } DeferredFB;

typedef struct {
    Camera      camera;
    char        vertical;
    char        mainlamp_on;
    char        shadows_ok;
    char        render_option;
    char        debug;
    TransBl     trans;
    LightBl     light;
    MatBl       mat;
    DeferredFB  dfb;
    GLuint      program_id[NPROGRAMS];
    GLint       prog7glowfctloc, prog7obscglloc;
    GLint       prog8passloc, prog8ngfloc;
    GLint       prog9glowfctloc, prog9obscglloc,
                prog9ssaorloc, prog9debugloc, prog9stageloc;
    GLfloat     glowfct, ssao_radius;
    GLint       ngf, obscgl;
    SceneObject room, door, lamp, carpet, table, chair[3],
                bookcase, galleon, candle;
  } AppData;

void LoadMyShaders ( AppData *ad );
void SetupDFBO ( DeferredFB *dfb, int w, int h );
void ResizeDFBO ( DeferredFB *dfb, int w, int h );
void DeleteDFBO ( DeferredFB *dfb );

void _RedrawMyWorld ( AppData *ad );

void DumpCubeShadowTexture ( GLuint txt );
void DumpBlurredLightTextures ( GLuint txt0, GLuint txt1, int w, int h );

