#version 450

layout (local_size_x=1) in;

layout (std430,binding = 0) buffer RowsCols { uint  rc[]; } rc;
layout (std430,binding = 1) buffer Coeff    { float a[]; } a;
layout (std430,binding = 2) buffer Xvec     { float x[]; } x;
layout (std430,binding = 3) buffer Yvec     { float y[]; } y;
layout (std430,binding = 4) buffer RowL     { uint  l[]; } lgt;
layout (std430,binding = 5) buffer Prod     { float b[]; } b;

uniform int  stage;
uniform uint m, nnz, dim, t;

#define r(i) rc.rc[i]
#define c(i) rc.rc[m+1+(i)]

void main ( void )
{
  uint i, j, k, l, u, v;

  i = gl_GlobalInvocationID.x;
  switch ( stage ) {
case 0:
    lgt.l[i] = r(i+1) - r(i);
    return;
case 1:
    if ( (j = i + (t+1)/2) < t )
      if ( lgt.l[j] > lgt.l[i] )
        lgt.l[i] = lgt.l[j];
    return;
case 2:
    for ( l = 0, u = i*dim, v = c(i)*dim;  l < dim;  l++)
      b.b[u++] = a.a[i] * x.x[v++];
    return;
case 3:
    j = gl_GlobalInvocationID.y;
    k = j + (t+1)/2;
    if ( k < lgt.l[i] && k < t ) {
      for ( l = 0, u = (r(i)+j)*dim, v = (r(i)+k)*dim;  l < dim;  l++ )
        b.b[u++] += b.b[v++];
    }
    return;
case 4:
    for ( l = 0, u = i*dim, v = r(i)*dim;  l < dim;  l++ )
      y.y[u++] = b.b[v++];
    return;
default:
    return;
  }
} /*main*/

