#version 430 core

#define MAXDEG 10

layout(isolines,equal_spacing) in;

uniform PaletteBlock {
    int   deg;
    vec4  cp[MAXDEG+1], bpcp[MAXDEG+1];
  } pal;

uniform TriangBlock {
    mat4x4 vpm, sqpm;
  } tr;

vec4 BCHornerf ( float t )
{
  int   i, b;
  float s, d;
  vec4  q;

  s = 1.0-t;  d = t;  b = pal.deg;
  q = pal.bpcp[0];
  for ( i = 1; i <= pal.deg; i++ ) {
    q = s*q + (b*d)*pal.bpcp[i];
    d *= t;  b = (b*(pal.deg-i))/(i+1);
  }
  return q;
} /*BCHornerf*/

void main ( void )
{
  gl_Position = tr.vpm * BCHornerf ( gl_TessCoord.x );
} /*main*/

