
#define MAX_NLIGHTS 8

typedef struct LSPar {
          GLfloat ambient[3];
          GLfloat direct[3];
          GLfloat position[4];
          GLfloat attenuation[3];
        } LSPar;

typedef struct HLPar {
          GLfloat zenith[3];
          GLfloat sky[4], ground[4];
        } HLPar;

typedef struct LightBl {
          GLuint lsbuf;
          GLuint nls, mask, hlen;
          HLPar  hl;
          LSPar  ls[MAX_NLIGHTS];
        } LightBl;

void SetLightAmbient ( LightBl *light, int l, GLfloat amb[3] );
void SetLightDirect ( LightBl *light, int l, GLfloat dir[3] );
void SetLightPosition ( LightBl *light, int l, GLfloat pos[4] );
void SetLightAttenuation ( LightBl *light, int l, GLfloat at3[3] );
void SetLightOnOff ( LightBl *light, int l, char on );

void SetHemisphericalLight ( LightBl *light, GLfloat zenith[3],
                             GLfloat sky[4], GLfloat ground[4] );
void SetHemisphericalLightOnOff ( LightBl *light, char on );
