#version 440

#define A 0.57735027  /* sqrt(1/3) */

layout(points) in;
layout(triangle_strip,max_vertices=12) out;

in int instanceID[];

out FVertex {
    vec3 Colour, Position, Normal, TNormal;
  } Out;

uniform TransBlock {
    mat4 mm, mmti, vm, pm, vpm;
    vec4 eyepos;
  } trb;

uniform int level;

const vec4 p[4] = { vec4(-A,-A,-A,1.0), vec4(A,A,-A,1.0),
                    vec4(-A,A,A,1.0), vec4(A,-A,A,1.0) };
const vec3 nv[4] = { vec3(-A,A,-A), vec3(-A,-A,A),
                     vec3(A,-A,-A), vec3(A,A,A) };
const vec3 col[4] = { vec3(1.0,0.0,0.0), vec3(0.0,1.0,0.0),
                      vec3(0.0,0.0,1.0), vec3(0.5,0.5,0.5) };
const int t[4][3] = {{1,2,3},{0,2,3},{0,1,3},{0,1,2}};
const int f[4][3] = {{0,1,2},{0,2,3},{0,3,1},{3,2,1}};

void main ( void )
{
  vec4 q[4], pos[4];
  vec3 c[4], n[4];
  int  i, j, k, l;

  for ( i = 0; i < 4; i++ ) { q[i] = p[i];  c[i] = col[i]; }
  for ( i = 0, j = instanceID[0];  i < level;  i++, j /= 4 ) {
    k = j % 4;
    for ( l = 0; l < 3; l++ )
      q[t[k][l]] = 0.5*(q[k] + q[t[k][l]]);
    for ( l = 0; l < 3; l++ )
      c[t[k][l]] = 0.5*(c[k] + c[t[k][l]]);
  }
  for ( i = 0; i < 4; i++ ) {
    n[i] = normalize ( mat3(trb.mmti) * nv[i] );
    pos[i] = trb.mm * q[i];
    q[i] = trb.vpm * pos[i];
  }
  for ( i = 0; i < 4; i++ ) {
    for ( j = 0; j < 3; j++ ) {
      k = f[i][j];
      gl_Position = q[k];
      Out.Position = pos[k].xyz;
      Out.Colour = c[k];
      Out.Normal = Out.TNormal = n[i];
      EmitVertex ();
    }
    EndPrimitive ();
  }
} /*main*/
