#include <stdlib.h>
#include "glad.h"
#include <GL/freeglut.h>

const GLchar *vertsh[] =
 {"#version 420 core\n"
  "out vec4 colour;"
  "const vec4 p[3] = {{0.9,-0.9,0,1},{0,0.9,0,1},{-0.9,-0.9,0,1}};"
  "const vec4 c[3] = {{1,0,0,1},{0,1,0,1},{0,0,1,1}};"
  "void main ( void )"
  "{"
    "gl_Position = p[gl_VertexID];"
    "colour = c[gl_VertexID];"
  "}"};
const GLchar *fragsh[] =
 {"#version 420 core\n"
  "in vec4 colour;"
  "out vec4 Colour;"
  "void main ( void )"
  "{"
    "Colour = colour;"
  "}"};

int    window;
GLuint prog_id, vao;

void DisplayFunc ( void )
{
  glClearColor ( 1.0, 1.0, 1.0, 1.0 );
  glClear ( GL_COLOR_BUFFER_BIT );
  glUseProgram ( prog_id );
  glBindVertexArray ( vao );
  glDrawArrays ( GL_TRIANGLES, 0, 3 );
  glBindVertexArray ( 0 );
  glUseProgram ( 0 );
  glFlush ();
  glutSwapBuffers ();
} /*DisplayFunc*/

void KeyboardFunc ( unsigned char key, int x, int y )
{
  if ( key == 0x1B ) {
    glDeleteVertexArrays ( 1, &vao );
    glDeleteProgram ( prog_id );
    glutDestroyWindow ( window );
    exit ( 0 );
  }
} /*KeyboardFunc*/

int main ( int argc, char *argv[] )
{
  GLuint sh_id[2];

  glutInit ( &argc, argv );
  glutInitContextVersion ( 2, 1 );
  glutInitContextFlags ( GLUT_FORWARD_COMPATIBLE );
  glutInitContextProfile ( GLUT_CORE_PROFILE );
  glutInitDisplayMode ( GLUT_DOUBLE | GLUT_RGBA );
  glutInitWindowSize ( 480, 360 );
  if ( !(window = glutCreateWindow ( "tr81" )) )
    exit ( 1 );
  if ( !gladLoadGL () )
    exit ( 1 );
  glutDisplayFunc ( DisplayFunc );
  glutKeyboardFunc ( KeyboardFunc );
  sh_id[0] = glCreateShader ( GL_VERTEX_SHADER );
  glShaderSource ( sh_id[0], 1, vertsh, NULL );
  glCompileShader ( sh_id[0] );
  sh_id[1] = glCreateShader ( GL_FRAGMENT_SHADER );
  glShaderSource ( sh_id[1], 1, fragsh, NULL );
  glCompileShader ( sh_id[1] );
  prog_id = glCreateProgram ();
  glAttachShader ( prog_id, sh_id[0] );
  glAttachShader ( prog_id, sh_id[1] );
  glLinkProgram ( prog_id );
  glDeleteShader ( sh_id[0] );
  glDeleteShader ( sh_id[1] );
  glGenVertexArrays ( 1, &vao );
  glutMainLoop ();
  exit ( 0 );
} /*main*/
